"""Defines custom types for colors and font styles."""

from typing import Literal, TypeAlias, Union

__all__ = ["Color", "FontStyle"]

Color: TypeAlias = Union[
    str,  # hex & rgb
    Literal[
        # Shades of Green
        "greenyellow",
        "chartreuse",
        "lawngreen",
        "lime",
        "limegreen",
        "palegreen",
        "mediumspringgreen",
        "springgreen",
        "mediumseagreen",
        "seagreen",
        "forestgreen",
        "green",
        "darkgreen",
        "yellowgreen",
        "olivedrab",
        "olive",
        "darkolivegreen",
        "mediumaquamarine",
        "darkseagreen",
        "lightseagreen",
        "darkcyan",
        "teal",
        # Shades of Blue
        "cyan",
        "aqua",
        "lightcyan",
        "paleturquoise",
        "aquamarine",
        "turquoise",
        "mediumturquoise",
        "darkturquoise",
        "cadetblue",
        "steelblue",
        "lightsteelblue",
        "powderblue",
        "lightblue",
        "skyblue",
        "lightskyblue",
        "deepskyblue",
        "dodgerblue",
        "cornflowerblue",
        "mediumslateblue",
        "royalblue",
        "blue",
        "mediumblue",
        "darkblue",
        "navy",
        "midnightblue",
        # Shades of Red
        "indianred",
        "lightcoral",
        "salmon",
        "darksalmon",
        "crimson",
        "red",
        "firebrick",
        "darkred",
        # Shades of Orange
        "lightsalmon",
        "coral",
        "tomato",
        "orangered",
        "darkorange",
        "orange",
        # Shades of Yellow
        "gold",
        "yellow",
        "lightyellow",
        "lemonchiffon",
        "lightgoldenrodyellow",
        "papayawhip",
        "moccasin",
        "peachpuff",
        "palegoldenrod",
        "khaki",
        "darkkhaki",
        # Shades of Purple
        "lavender",
        "thistle",
        "plum",
        "violet",
        "orchid",
        "magenta",
        "fuchsia",
        "mediumorchid",
        "mediumpurple",
        "blueviolet",
        "darkviolet",
        "darkorchid",
        "darkmagenta",
        "purple",
        "rebeccapurple",
        "indigo",
        "slateblue",
        "darkslateblue",
        # Shades of Pink
        "pink",
        "lightpink",
        "hotpink",
        "deeppink",
        "mediumvioletred",
        "palevioletred",
        # Shades of Brown
        "cornsilk",
        "blanchedalmond",
        "bisque",
        "navajowhite",
        "wheat",
        "burlywood",
        "tan",
        "rosybrown",
        "sandybrown",
        "goldenrod",
        "darkgoldenrod",
        "peru",
        "chocolate",
        "saddlebrown",
        "sienna",
        "maroon",
        "brown",
        # Shades of Grey
        "gainsboro",
        "lightgrey",
        "lightgray",
        "silver",
        "darkgrey",
        "darkgray",
        "grey",
        "gray",
        "dimgrey",
        "dimgray",
        "lightslategrey",
        "lightslategray",
        "slategrey",
        "slategray",
        "darkslategrey",
        "darkslategray",
        "black",
        # Shades of White
        "white",
        "snow",
        "honeydew",
        "mintcream",
        "azure",
        "aliceblue",
        "ghostwhite",
        "whitesmoke",
        "seashell",
        "beige",
        "oldlace",
        "floralwhite",
        "ivory",
        "antiquewhite",
        "linen",
        "lavenderblush",
        "mistyrose",
    ],
]

FontStyle: TypeAlias = Union[
    str,  # combininations
    Literal[
        "bold",
        "italic",
        "underline",
        "hidden",
        "strikethrough",
        "double-underline",
        "overline",
    ],
]
